Description

Recently | learned that Perl's -0 option is extended to accept a hexadecimal Unicode codepoint.
However it uses -0x, and since -x is used for shebang and cd, it would cause a backward incompatibility if we will incorporate it as it
is.

So | propose that -OuCODEPOINT instead.
This can be extended to comma- or colon-separated codepoint list.

Also, another idea is -0:sepaerator which specifies the separator as-is.
Considering many of modern shells provide escaped string form (e.g., "$"uHHHH'), this may be a more modern answer, except for
NUL cannot be represented.

https://github.com/ruby/ruby/pull/7914

History

#1 - 06/07/2023 02:00 PM - Dan0042 (Daniel DeLorme)

It's a nifty idea, but -OUCODEPOINT means that the -u option is forever reserved for this usage which no one will ever really use | think, because -0 is
meant to be used like xargs -0 option (ex: find . -print0 | ruby -One 'p $_.chomp') and | can't imagine why anyone would use anything other than NUL.
Although | would love to be shown wrong.

-0:separator doesn't have that downside.

#2 - 06/07/2023 02:25 PM - nobu (Nobuyoshi Nakada)
| thought the issue about -u is simply a matter of priorities; just the chance of -0x cannot be denied, but -Ou should have never been used.
But now | remembered -U has been implemented since 1.9.

My patch allows -0U as well as -Ou, and would need to change.
Probably a punctuation (like as :) may be possible.

#3 - 06/07/2023 03:39 PM - Dan0042 (Daniel DeLorme)

I meant it will not be possible to use -u in the future.

With colon we could write anything after, like -0:$"\t' or -0:011 or -0:x09 or -0:u0009 or -0:01001 oo
Or use = instead of : ?

Cheers.

#4 - 06/07/2023 11:46 PM - nobu (Nobuyoshi Nakada)

Dan0042 (Daniel DeLorme) wrote in #note-3:

I meant it will not be possible to use -u in the future.

Yes, and | thought it wouldn’t be a problem, but might not be a good idea.

With colon we could write anything after, like -0:$"\t' or -0:011 or -0:x09 or -0:u0009 or -0:01001 oo
Or use = instead of : ?

-0=$"t' and -0:09(= -0:x09)?

#5 - 06/08/2023 08:12 AM - matz (Yukihiro Matsumoto)
- Status changed from Open to Rejected

Very few users know the existence of -0. If we extend the option, probably no one uses the feature.

07/21/2025 1/2



https://github.com/ruby/ruby/pull/7914

Matz.
